////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GL_H__0EE9BFBD_2D61_4610_828C_AEE4D0FC619C__INCLUDED_)
#define AFX_GL_H__0EE9BFBD_2D61_4610_828C_AEE4D0FC619C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "importexport.h"
#include "cglvector3.h"
#include "cglcolor.h"
#include "cgllabel.h"
#include "cglbutton.h"
#include "cgleditbox.h"
#include "cglframe.h"
#include "cgllistbox.h"
#include "cglslider.h"
#include "cgltextbox.h"
#include "cglerrorstrings.h"
#include <list>
#include <iterator>
using std::list;
using std::reverse_iterator;
typedef list<CGLControl*> CONTROLS_LIST;




#define CGL_PI 3.141592653589793
#define CGL_2PI 6.28318530717958

typedef void PFNTIMERPROC(GLint) ;
typedef void PFNRENDERPROC(void);
typedef void PFNSPECIALKEYPROC(GLint,GLint,GLint);
typedef void PFNKEYBOARDPROC(char,GLint,GLint);
typedef void PFNMOUSEPROC(GLint,GLint,GLint,GLint);
typedef void PFNRESIZEPROC(int,int);
typedef void PFNMOUSEMOVEPROC(int,int);

class  CGL_API CGL {

private:
	static int n;
	static GLsizei m_siWidth;
	static GLsizei m_siHeight;
	static GLfloat m_fLetterSize;
	static GLfloat m_fAspectRatio;
	static GLfloat m_fControlsDepth;

	static PFNTIMERPROC *m_pfnOnTimer;
	static PFNRENDERPROC * m_pfnOnRender;
	static PFNSPECIALKEYPROC * m_pfnOnSpecialKey;
	static PFNMOUSEPROC * m_pfnOnMouse;
	static PFNKEYBOARDPROC* m_pfnOnKeyboard;
	static PFNRESIZEPROC* m_pfnOnResize;
	static PFNMOUSEMOVEPROC* m_pfnMouseMove;
	static GLint m_nTimerDelay;
	static CONTROLS_LIST m_lstControls;
	static CONTROLS_LIST::iterator * m_iSelectedControl;

	static GLfloat **m_pLetters;
	static GLboolean m_bAllControlsRemoved;
	static void InitFont(void);


public:
	CGL(char *WindowTitle);


	virtual ~CGL();
	static void  MainLoop(void);
	static void OnTimer(GLint value);
	static void InitOpenGL(char * WindowTitle, int *argc,char *argv[]);
	static void Render();
	static void OnIdle();
	static void OnResize(GLsizei w, GLsizei h);
	static void OnSpecialKey(GLint p_nKey, GLint p_nx,GLint p_ny);
	static void OnKeyboard(unsigned char p_chKey, GLint p_nx,GLint p_ny);
	static void OnMouse(GLint p_nButton,GLint p_nState, GLint p_nx,GLint p_ny);
	static void OnMouseMove(int p_nx, int p_ny);
	static GLsizei GetWidth(void) {return m_siWidth;}
	static GLsizei GetHeight(void) {return m_siHeight;}
	static GLfloat GetAspectRatio(void) {return m_fAspectRatio;}
	static GLfloat GetControlsDepth(void) {return m_fControlsDepth;}

	static GLint GetTimerDelay(void) {return m_nTimerDelay;}
	static GLfloat GetLetterSize(void) {return m_fLetterSize;}
	static void SetTimerProc(PFNTIMERPROC *p_pfnOnTimer){m_pfnOnTimer=p_pfnOnTimer;}
	static void SetRenderProc(PFNRENDERPROC * p_pfnOnRender) {m_pfnOnRender=p_pfnOnRender;}
	static void SetSpecialKeyProc(PFNSPECIALKEYPROC * p_pfnOnSpecialKey) {m_pfnOnSpecialKey=p_pfnOnSpecialKey;}
	static void SetKeyboardProc(PFNKEYBOARDPROC * p_pfnOnSpecialKey) {m_pfnOnKeyboard=p_pfnOnSpecialKey;}
	static void SetResizeProc(PFNRESIZEPROC* p_pfnOnResize) {m_pfnOnResize=p_pfnOnResize;}
	static void SetPointLight(GLint p_nIndex,const CGLVector3 & p_fPosition,const CGLColor & p_fColor);
	static void SetSpotLight(GLint p_nIndex,const CGLVector3 & p_fPosition,const CGLVector3 & p_fDirection,
				const CGLColor & p_fColor);
	static void SetMaterial(const CGLColor & p_Color,GLfloat p_fPower);

	static GLboolean AddControl(const CGLControl* p_pControl);
	static void RemoveAllControls(void) ;
	static void DrawText(GLfloat p_nx, GLfloat p_ny,GLfloat p_nWidth, GLfloat p_nHeight,const char * str,GLint p_nStringLength);

    static void WindowPosToGLPos(int p_nx,int p_ny, float * p_fx, float * p_fy);

};





#endif // !defined(AFX_GL_H__0EE9BFBD_2D61_4610_828C_AEE4D0FC619C__INCLUDED_)
