////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#include "cglstdafx.h"
#include "cglcontrol.h"

CGLControl *CGLControl::m_SelectedControl=NULL;
#define z -1.0

static inline GLfloat ConvertPosition(GLfloat x)
{
	return x*2-1.0;
}

static inline GLfloat UnconvertPosition(GLfloat x)
{
    return (1.0+x)/2;
}
CGLControl::CGLControl(GLfloat p_fx,GLfloat p_fy,
	GLfloat p_fWidth,GLfloat p_fHeight)
{
    if ((p_fx>1.0)||(p_fx<0.0))
        throw CGL_ERROR_INVALID_ARGUMENT;
	m_fx=+ConvertPosition(p_fx);
	if ((p_fy>1.0)||(p_fy<0.0))
        throw CGL_ERROR_INVALID_ARGUMENT;
	m_fy=-ConvertPosition(p_fy);
	if ((p_fWidth>1.0)||(p_fWidth<0.0))
        throw CGL_ERROR_INVALID_ARGUMENT;
	m_fWidth=p_fWidth*2;
	if ((p_fHeight>1.0)||(p_fHeight<0.0))
        throw CGL_ERROR_INVALID_ARGUMENT;
	m_fHeight=p_fHeight*2;
	if (!CGL::AddControl(this)) throw 1;
}
void CGLControl::Draw(void)
{
    float fz=CGL::GetControlsDepth();
    GLfloat fLastColor[4],fDepthColor[4];
    glGetFloatv(GL_CURRENT_COLOR,fLastColor);
    memcpy((void*)fDepthColor,(const void*)fLastColor,3*sizeof(GLfloat));
    fDepthColor[3]=fLastColor[3]/2;



	glBegin(GL_QUADS);
		glVertex3f(m_fx+m_fWidth,m_fy-m_fHeight,z);
		glVertex3f(m_fx+m_fWidth,m_fy,z);
		glVertex3f(m_fx,m_fy,z);
		glVertex3f(m_fx,m_fy-m_fHeight,z);


        glColor4fv(fDepthColor);
        glVertex3f(m_fx+m_fWidth,m_fy-m_fHeight,z-fz);
        glVertex3f(m_fx+m_fWidth,m_fy,z-fz);
        glVertex3f(m_fx+m_fWidth,m_fy,z);
		glVertex3f(m_fx+m_fWidth,m_fy-m_fHeight,z);

		glVertex3f(m_fx,m_fy-m_fHeight,z);
		glVertex3f(m_fx,m_fy,z);
        glVertex3f(m_fx,m_fy,z-fz);
		glVertex3f(m_fx,m_fy-m_fHeight,z-fz);

		glVertex3f(m_fx,m_fy,z-fz);
		glVertex3f(m_fx,m_fy,z);
		glVertex3f(m_fx+m_fWidth,m_fy,z);
		glVertex3f(m_fx+m_fWidth,m_fy,z-fz);

        glVertex3f(m_fx+m_fWidth,m_fy-m_fHeight,z-fz);
        glVertex3f(m_fx+m_fWidth,m_fy-m_fHeight,z);
        glVertex3f(m_fx,m_fy-m_fHeight,z);
		glVertex3f(m_fx,m_fy-m_fHeight,z-fz);



	glEnd();
    glColor4fv(fLastColor);

}

GLfloat CGLControl::GetX()
{
    return UnconvertPosition(m_fx);
}

GLfloat CGLControl::GetY()
{
    return UnconvertPosition(m_fy);
}

GLfloat CGLControl::GetWidth()
{
    return m_fWidth/2;
}

GLfloat CGLControl::GetHeight()
{
    return m_fHeight/2;
}


