////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#include "cglstdafx.h"
#include "cgltextbox.h"

#define z -1.0

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGLTextBox::CGLTextBox(GLfloat p_fx,GLfloat p_fy,
	GLfloat p_fWidth,GLfloat p_fHeight,
	const string p_strText)
	:CGLLabel(p_fx,p_fy,p_fWidth,p_fHeight,p_strText)
{
	m_nCurrentScrollPosition=0;
}


void CGLTextBox::Draw()
{
	GLint nTextLength=m_strText.length();
	GLfloat fSM=CGL::GetLetterSize();
	GLfloat fTextX=m_fx+fSM,fTextY=m_fy-fSM,fTextWidth=m_fWidth-fSM*2,fTextHeight=m_fHeight-fSM*2;
	GLfloat fLastColor[4];
	glGetFloatv(GL_CURRENT_COLOR,fLastColor);
	CGLControl::Draw();
	glColor3f(0.0,0.0,0.0);
	glBegin(GL_QUADS);
		glVertex3f(fTextX+fTextWidth,fTextY-fTextHeight,z);
		glVertex3f(fTextX+fTextWidth,fTextY,z);
		glVertex3f(fTextX,fTextY,z);
		glVertex3f(fTextX,fTextY-fTextHeight,z);
	glEnd();

	GLint n,m=0,k=(GLint)(fTextWidth/fSM);
	for (n=0; n<m_nCurrentScrollPosition;n++)
	{
		if (m+k>nTextLength) {m_nCurrentScrollPosition--;break;}
		m=GetWordWrapPosition(m,m+k);
	}
	CGL::DrawText(fTextX,fTextY,fTextWidth,fTextHeight,&m_strText[m],nTextLength-m);//-  !!!!!!!!!!!!

	glRasterPos4f(m_fx+m_fWidth-fSM,m_fy-fSM,-1.0,1.0f);
	glDrawPixels(8,8,GL_GREEN,GL_UNSIGNED_BYTE,(const GLvoid *)(g_abyUpPixels));
	glRasterPos4f(m_fx+m_fWidth-fSM,m_fy-m_fHeight,-1.0,1.0f);
	glDrawPixels(8,8,GL_GREEN,GL_UNSIGNED_BYTE,(const GLvoid *)(g_abyDownPixels));
	glColor4fv(fLastColor);
}


void CGLTextBox::OnMouse(GLint p_nButton,GLint p_nState,GLfloat p_fx,GLfloat p_fy)
{
	if (p_nState==GLUT_DOWN)
	{
		GLfloat fSM=CGL::GetLetterSize();
		GLfloat fRight=m_fx+m_fWidth,fTop=m_fy,
		fLeft=fRight-fSM,fBottom=fTop-fSM;
		//fTextWidth=m_fWidth-fSM*2;
		if ((fLeft<=p_fx)&&(fTop>=p_fy)&&(fRight>=p_fx)&&(fBottom<=p_fy))
		{
			if (m_nCurrentScrollPosition>0)m_nCurrentScrollPosition--;
		}
		fBottom=m_fy-m_fHeight;
		fTop=fBottom+fSM;
		if ((fLeft<=p_fx)&&(fTop>=p_fy)&&(fRight>=p_fx)&&(fBottom<=p_fy))
		{
			m_nCurrentScrollPosition++;
		}
	}
}

GLint CGLTextBox::GetWordWrapPosition(GLint p_nFirst, GLint p_nEnd)
{

	GLint n,nTextLength=m_strText.length();
	if (p_nEnd<nTextLength)
	{
		n=p_nEnd;
		while ((m_strText[n]!=' ')&&(n>0)) n--;
		if (n>p_nFirst) p_nEnd=n+1;
	}
	else
	{
		p_nEnd=nTextLength;
	}
	return p_nEnd;
}


void CGLTextBox::OnSpecialKey(GLint p_nKey,GLint p_nx,GLint p_ny)
{
	switch (p_nKey)
	{
	case GLUT_KEY_UP:
	case GLUT_KEY_PAGE_UP:
		if (m_nCurrentScrollPosition>0) m_nCurrentScrollPosition--;
		break;
	case GLUT_KEY_DOWN:
	case GLUT_KEY_PAGE_DOWN:
		m_nCurrentScrollPosition++;
		break;
	}
}

CGLTextBox::~CGLTextBox()
{

}
